/**********************************************************
 * Change tables to InnoDB and Add Foriegn Key Mapping
 ***********************************************************/
ALTER TABLE `addresses` ENGINE=InnoDB;
ALTER TABLE ar_activity MODIFY COLUMN sequence_no INT;
ALTER TABLE ar_activity DROP PRIMARY KEY;
ALTER TABLE ar_activity ADD PRIMARY KEY (sequence_no);
ALTER TABLE ar_activity MODIFY COLUMN sequence_no INT unsigned NOT NULL auto_increment;
ALTER TABLE ar_activity ADD UNIQUE (pid, encounter, sequence_no);
ALTER TABLE `ar_activity` ENGINE=InnoDB;
ALTER TABLE `ar_session` ENGINE=InnoDB;
ALTER TABLE `array` ENGINE=InnoDB;
ALTER TABLE `automatic_notification` ENGINE=InnoDB;
ALTER TABLE `batchcom` ENGINE=InnoDB;
ALTER TABLE `billing` ENGINE=InnoDB;
ALTER TABLE `categories` ENGINE=InnoDB;
ALTER TABLE `categories_seq` ENGINE=InnoDB;
ALTER TABLE `categories_to_documents` ENGINE=InnoDB;
ALTER TABLE `chart_tracker` ENGINE=InnoDB;
ALTER TABLE claims MODIFY COLUMN version INT;
ALTER TABLE claims DROP PRIMARY KEY;
ALTER TABLE claims ADD PRIMARY KEY (version);
ALTER TABLE claims MODIFY COLUMN version INT unsigned NOT NULL auto_increment;
ALTER TABLE claims ADD UNIQUE (patient_id, encounter_id, version);
ALTER TABLE `claims` ENGINE=InnoDB;
ALTER TABLE `code_types` ENGINE=InnoDB;
ALTER TABLE `codes` ENGINE=InnoDB;
ALTER TABLE `config` ENGINE=InnoDB;
ALTER TABLE `config_seq` ENGINE=InnoDB;
ALTER TABLE `documents` ENGINE=InnoDB;
ALTER TABLE `drug_inventory` ENGINE=InnoDB;
ALTER TABLE `drug_sales` ENGINE=InnoDB;
ALTER TABLE `drug_templates` ENGINE=InnoDB;
ALTER TABLE `drugs` ENGINE=InnoDB;
ALTER TABLE `employer_data` ENGINE=InnoDB;
ALTER TABLE `facility` ENGINE=InnoDB;
ALTER TABLE `fee_sheet_options` ENGINE=InnoDB;
ALTER TABLE `form_dictation` ENGINE=InnoDB;
ALTER TABLE `form_encounter` ENGINE=InnoDB;
ALTER TABLE `form_misc_billing_options` ENGINE=InnoDB;
ALTER TABLE `form_reviewofs` ENGINE=InnoDB;
ALTER TABLE `form_ros` ENGINE=InnoDB;
ALTER TABLE `form_soap` ENGINE=InnoDB;
ALTER TABLE `form_vitals` ENGINE=InnoDB;
ALTER TABLE `forms` ENGINE=InnoDB;
ALTER TABLE `gacl_acl` ENGINE=InnoDB;
ALTER TABLE `gacl_acl_sections` ENGINE=InnoDB;
ALTER TABLE `gacl_acl_seq` ENGINE=InnoDB;
ALTER TABLE `gacl_aco` ENGINE=InnoDB;
ALTER TABLE `gacl_aco_map` ENGINE=InnoDB;
ALTER TABLE `gacl_aco_sections` ENGINE=InnoDB;
ALTER TABLE `gacl_aco_sections_seq` ENGINE=InnoDB;
ALTER TABLE `gacl_aco_seq` ENGINE=InnoDB;
ALTER TABLE `gacl_aro` ENGINE=InnoDB;
ALTER TABLE `gacl_aro_groups` ENGINE=InnoDB;
ALTER TABLE `gacl_aro_groups_id_seq` ENGINE=InnoDB;
ALTER TABLE `gacl_aro_groups_map` ENGINE=InnoDB;
ALTER TABLE `gacl_aro_map` ENGINE=InnoDB;
ALTER TABLE `gacl_aro_sections` ENGINE=InnoDB;
ALTER TABLE `gacl_aro_sections_seq` ENGINE=InnoDB;
ALTER TABLE `gacl_aro_seq` ENGINE=InnoDB;
ALTER TABLE `gacl_axo` ENGINE=InnoDB;
ALTER TABLE `gacl_axo_groups` ENGINE=InnoDB;
ALTER TABLE `gacl_axo_groups_map` ENGINE=InnoDB;
ALTER TABLE `gacl_axo_map` ENGINE=InnoDB;
ALTER TABLE `gacl_axo_sections` ENGINE=InnoDB;
ALTER TABLE `gacl_groups_aro_map` ENGINE=InnoDB;
ALTER TABLE `gacl_groups_axo_map` ENGINE=InnoDB;
ALTER TABLE `gacl_phpgacl` ENGINE=InnoDB;
ALTER TABLE `geo_country_reference` ENGINE=InnoDB;
ALTER TABLE `geo_zone_reference` ENGINE=InnoDB;
ALTER TABLE `globals` ENGINE=InnoDB;
ALTER TABLE `gprelations` ENGINE=InnoDB;
ALTER TABLE `groups` ENGINE=InnoDB;
ALTER TABLE `history_data` ENGINE=InnoDB;
ALTER TABLE `immunizations` ENGINE=InnoDB;
ALTER TABLE `insurance_companies` ENGINE=InnoDB;
ALTER TABLE `insurance_data` ENGINE=InnoDB;
ALTER TABLE `insurance_numbers` ENGINE=InnoDB;
ALTER TABLE `integration_mapping` ENGINE=InnoDB;
ALTER TABLE `issue_encounter` ENGINE=InnoDB;
ALTER TABLE `lang_constants` ENGINE=InnoDB;
ALTER TABLE `lang_custom` ENGINE=InnoDB;
ALTER TABLE `lang_definitions` ENGINE=InnoDB;
ALTER TABLE `lang_languages` ENGINE=InnoDB;
ALTER TABLE `layout_options` ENGINE=InnoDB;
ALTER TABLE `lbf_data` ENGINE=InnoDB;
ALTER TABLE `list_options` ENGINE=InnoDB;
ALTER TABLE `lists` ENGINE=InnoDB;
ALTER TABLE `log` ENGINE=InnoDB;
ALTER TABLE `notes` ENGINE=InnoDB;
ALTER TABLE `notification_log` ENGINE=InnoDB;
ALTER TABLE `notification_settings` ENGINE=InnoDB;
ALTER TABLE `onotes` ENGINE=InnoDB;
ALTER TABLE `openemr_module_vars` ENGINE=InnoDB;
ALTER TABLE `openemr_modules` ENGINE=InnoDB;
ALTER TABLE `openemr_postcalendar_categories` ENGINE=InnoDB;
ALTER TABLE `openemr_postcalendar_events` ENGINE=InnoDB;
ALTER TABLE `openemr_postcalendar_limits` ENGINE=InnoDB;
ALTER TABLE `openemr_postcalendar_topics` ENGINE=InnoDB;
ALTER TABLE `openemr_session_info` ENGINE=InnoDB;
ALTER TABLE `patient_data` ENGINE=InnoDB;
ALTER TABLE `payments` ENGINE=InnoDB;
ALTER TABLE `pharmacies` ENGINE=InnoDB;
ALTER TABLE `phone_numbers` ENGINE=InnoDB;
ALTER TABLE `pma_bookmark` ENGINE=InnoDB;
ALTER TABLE `pma_column_info` ENGINE=InnoDB;
ALTER TABLE `pma_history` ENGINE=InnoDB;
ALTER TABLE `pma_pdf_pages` ENGINE=InnoDB;
ALTER TABLE `pma_relation` ENGINE=InnoDB;
ALTER TABLE `pma_table_coords` ENGINE=InnoDB;
ALTER TABLE `pma_table_info` ENGINE=InnoDB;
ALTER TABLE `pnotes` ENGINE=InnoDB;
ALTER TABLE `prescriptions` ENGINE=InnoDB;
ALTER TABLE `prices` ENGINE=InnoDB;
ALTER TABLE `procedure_order` ENGINE=InnoDB;
ALTER TABLE `procedure_report` ENGINE=InnoDB;
ALTER TABLE `procedure_result` ENGINE=InnoDB;
ALTER TABLE `procedure_type` ENGINE=InnoDB;
ALTER TABLE `registry` ENGINE=InnoDB;
ALTER TABLE `sequences` ENGINE=InnoDB;
ALTER TABLE `syndromic_surveillance` ENGINE=InnoDB;
ALTER TABLE `transactions` ENGINE=InnoDB;
ALTER TABLE `users` ENGINE=InnoDB;
ALTER TABLE `users_facility` ENGINE=InnoDB;
ALTER TABLE `x12_partners` ENGINE=InnoDB;

ALTER TABLE ar_activity ADD FOREIGN KEY (session_id) REFERENCES ar_session (session_id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE ar_activity MODIFY COLUMN pid bigint(20) NOT NULL;
ALTER TABLE ar_activity ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE ar_session MODIFY COLUMN user_id bigint(20) NOT NULL;
ALTER TABLE ar_session ADD FOREIGN KEY (user_id) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE ar_session ADD FOREIGN KEY (payer_id) REFERENCES insurance_companies (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE batchcom ADD FOREIGN KEY (sent_by) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE batchcom MODIFY COLUMN patient_id bigint(20) NOT NULL;
ALTER TABLE batchcom ADD FOREIGN KEY (patient_id) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE billing MODIFY COLUMN provider_id bigint(20) NOT NULL;
ALTER TABLE billing ADD FOREIGN KEY (provider_id) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE billing MODIFY COLUMN `user` bigint(20) NOT NULL;
ALTER TABLE billing ADD FOREIGN KEY (`user`) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE billing ADD FOREIGN KEY (x12_partner_id) REFERENCES x12_partners (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE billing MODIFY COLUMN pid bigint(20) NOT NULL;
ALTER TABLE billing ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE billing ADD FOREIGN KEY (payer_id) REFERENCES insurance_companies (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE billing MODIFY COLUMN encounter int(11) DEFAULT NULL;

ALTER TABLE categories_to_documents ADD FOREIGN KEY (category_id) REFERENCES categories (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE categories_to_documents ADD FOREIGN KEY (document_id) REFERENCES documents (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE chart_tracker MODIFY COLUMN `ct_pid` bigint(20) NOT NULL;
ALTER TABLE chart_tracker ADD FOREIGN KEY (ct_pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE chart_tracker MODIFY COLUMN `ct_userid` bigint(20) NOT NULL;
ALTER TABLE chart_tracker ADD FOREIGN KEY (ct_userid) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;


ALTER TABLE claims MODIFY COLUMN `patient_id` bigint(20) NOT NULL;
ALTER TABLE claims ADD FOREIGN KEY (patient_id) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE claims MODIFY COLUMN `payer_id` int(11) NOT NULL;
ALTER TABLE claims ADD FOREIGN KEY (payer_id) REFERENCES insurance_companies (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE claims MODIFY COLUMN `x12_partner_id` int(11) DEFAULT NULL;
ALTER TABLE claims ADD FOREIGN KEY (x12_partner_id) REFERENCES x12_partners (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE codes MODIFY COLUMN `code_type` int(11) DEFAULT NULL;
ALTER TABLE codes ADD FOREIGN KEY (code_type) REFERENCES code_types (ct_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE documents ADD FOREIGN KEY (list_id) REFERENCES lists (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE drug_inventory ADD FOREIGN KEY (drug_id) REFERENCES drugs (drug_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE drug_sales ADD FOREIGN KEY (drug_id) REFERENCES drugs (drug_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE drug_templates ADD FOREIGN KEY (drug_id) REFERENCES drugs (drug_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE employer_data ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE form_dictation ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE form_encounter ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE form_encounter MODIFY COLUMN `pc_catid` int(11) unsigned  DEFAULT NULL;
ALTER TABLE form_encounter ADD FOREIGN KEY (pc_catid) REFERENCES openemr_postcalendar_categories (pc_catid) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE form_encounter MODIFY COLUMN `provider_id` bigint(20) DEFAULT NULL;
ALTER TABLE form_encounter ADD FOREIGN KEY (provider_id ) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE form_encounter MODIFY COLUMN `supervisor_id` bigint(20) DEFAULT NULL;
ALTER TABLE form_encounter ADD FOREIGN KEY (supervisor_id ) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE form_misc_billing_options ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE form_reviewofs ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE form_ros MODIFY COLUMN `pid` bigint(20) DEFAULT NULL;
ALTER TABLE form_ros ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE form_soap ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE form_vitals ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE forms ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE geo_zone_reference ADD FOREIGN KEY (zone_country_id) REFERENCES geo_country_reference (countries_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE history_data ADD FOREIGN KEY (pid ) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE immunizations MODIFY COLUMN `patient_id` bigint(20) DEFAULT NULL;
ALTER TABLE immunizations ADD FOREIGN KEY (patient_id) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;


ALTER TABLE insurance_data ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE insurance_numbers MODIFY COLUMN `provider_id` bigint(20) DEFAULT NULL;
ALTER TABLE insurance_numbers ADD FOREIGN KEY (provider_id) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE insurance_numbers ADD FOREIGN KEY (insurance_company_id) REFERENCES insurance_companies(id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE issue_encounter MODIFY COLUMN `list_id` bigint(20) DEFAULT NULL;
ALTER TABLE issue_encounter ADD FOREIGN KEY (list_id) REFERENCES lists(id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE lang_definitions ADD FOREIGN KEY (cons_id) REFERENCES lang_constants (cons_id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE lang_definitions ADD FOREIGN KEY (lang_id) REFERENCES lang_languages (lang_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE lbf_data MODIFY COLUMN `form_id` bigint(20) DEFAULT NULL;
ALTER TABLE lbf_data ADD FOREIGN KEY (form_id) REFERENCES forms (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE log MODIFY COLUMN `patient_id` bigint(20) DEFAULT NULL;
ALTER TABLE log ADD FOREIGN KEY (patient_id) REFERENCES patient_data(id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE openemr_postcalendar_events MODIFY COLUMN `pc_catid` int(11) unsigned;
ALTER TABLE openemr_postcalendar_events ADD FOREIGN KEY (pc_catid) REFERENCES openemr_postcalendar_categories (pc_catid) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE openemr_postcalendar_limits MODIFY COLUMN `pc_catid` int(11) unsigned;
ALTER TABLE openemr_postcalendar_limits ADD FOREIGN KEY (pc_catid) REFERENCES openemr_postcalendar_categories (pc_catid) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE payments ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE pnotes ADD FOREIGN KEY (pid) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE prescriptions MODIFY COLUMN `patient_id` bigint(20) ;
ALTER TABLE prescriptions ADD FOREIGN KEY (patient_id) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE prescriptions MODIFY COLUMN `provider_id` bigint(20) ;
ALTER TABLE prescriptions ADD FOREIGN KEY (provider_id) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE prescriptions ADD FOREIGN KEY (drug_id) REFERENCES drugs (drug_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE procedure_order ADD FOREIGN KEY (provider_id) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE procedure_order ADD FOREIGN KEY (patient_id) REFERENCES patient_data (id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE procedure_order ADD FOREIGN KEY (encounter_id) REFERENCES form_encounter (id) ON UPDATE CASCADE ON DELETE CASCADE;


ALTER TABLE procedure_report ADD FOREIGN KEY (procedure_order_id) REFERENCES procedure_order (procedure_order_id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE procedure_report ADD FOREIGN KEY (source) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE procedure_result ADD FOREIGN KEY (procedure_report_id) REFERENCES procedure_report (procedure_report_id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE procedure_result ADD FOREIGN KEY (procedure_type_id) REFERENCES procedure_type (procedure_type_id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE procedure_type ADD FOREIGN KEY (parent) REFERENCES procedure_type (procedure_type_id) ON UPDATE CASCADE ON DELETE CASCADE;
ALTER TABLE procedure_type ADD FOREIGN KEY (lab_id) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE transactions ADD FOREIGN KEY (pid) REFERENCES users (id) ON UPDATE CASCADE ON DELETE CASCADE;

ALTER TABLE users_facility ADD FOREIGN KEY (facility_id) REFERENCES facility (id) ON UPDATE CASCADE ON DELETE CASCADE;

